class oZelle extends Zelle
{
  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  float r1;                                // Radius bei der 1. Berhrung
  float r2;                                // Radius bei der 2. Berhrung
  float xB1;                               // relativer x-Wert bei der 1. Berhrung
  float yB1;                               // relativer y-Wert bei der 1. Berhrung  
  float xB2;                               // relativer x-Wert bei der 2. Berhrung
  float yB2;                               // relativer y-Wert bei der 2. Berhrung
  float [] z1 = new float [2];             // Koordinaten des Mittelpunkts des 1. Berhrungskreises  
  float [] z2 = new float [2];             // Koordinaten des Mittelpunkts des 2. Berhrungskreises  
  // color c1;                             // Farbe bei der 1. Berhrung
  // color c2;                             // Farbe bei der 2. Berhrung


  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  oZelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }



  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  void setBeruehrungspunkt ()                          // Daten der Berhrungen werden in Variabeln geschrieben
  {
    switch (AnzahlBeruehrungen)
    {
    case 1:
      r1 = rZelle;
      xB1 = Beruehrungspunkt [0] - xZelle;
      yB1 = Beruehrungspunkt [1] - yZelle;

    case 2:
      r2 = rZelle;
      xB2 = Beruehrungspunkt [2] - xZelle;
      yB2 = Beruehrungspunkt [3] - yZelle;
      
      /*
      float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
      float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
      float AbstandMitte = sqrt(sq(xMitte -xZelle) + sq(yMitte -yZelle));
      xB2 = r2/AbstandMitte * xMitte;
      yB2 = r2/AbstandMitte * yMitte;
      */
    }
  }    

  //--------------------------------------------------------------------------------------------------

  void zeichnen ()                                      // berdeckt die Methode in der Mutterklasse
  {
    switch (AnzahlBeruehrungen)
    {
    case 0:
      zeichne_Kreis (xZelle, yZelle, rZelle, c2);
      if (rZelle > Rand)
      {
        zeichne_Kreis (xZelle, yZelle, rZelle-Rand, c1);
      }
      break;

    case 1:
      zeichne_Kreis (xZelle, yZelle, rZelle, c2);
      z1 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB1, yB1, r1, c1);
      break;

    case 2:
      zeichne_Kreis (xZelle, yZelle, rZelle, c3);
      z2 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB2, yB2, r2, c2);
      z1 = zeichne_KreisInKreis (z2 [0], z2 [1], r2, xB1, yB1, r1, c1);
      break;
    }
  }  

  //--------------------------------------------------------------------------------------------------
  
  void zeichnen_Kreis0a ()                                      // zeichnet Kreis der ursprnglichen Kreis Berhrung
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
    if (rZelle > Rand)
    {
      fill (c1);
      ellipse (xZelle, yZelle, rZelle-Rand, rZelle-Rand);
    }
  }  

  //--------------------------------------------------------------------------------------------------
  void zeichnen_Kreis0b ()                                      // zeichnet Kreis der ursprnglichen Kreis Berhrung
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }  


  //--------------------------------------------------------------------------------------------------

  void setFertig (boolean f)                           // berdecket die Methode in Mutterklasse
  {
    fertig = f;
  }    

  // --------------------------------------------------------------------------------------------------
}
